/**
 * @author Stefanie Fritz
 */
public class Hamming_Distance {

    public static void main(String[] args) {
        String[] strings = {"HAHAHA", "AHAAAA", "HHMMMM", "HAMM"};
        int numberOfStrings = strings.length;

        // vergleiche alle Strings mit allen Andern
        String distance;
        for (int i = 0; i < numberOfStrings; i++) {
            for (int j = i + 1; j < numberOfStrings; j++) {
                distance = singleHamming_Distance(strings[i], strings[j]);
                System.out.println("Hamming Distance zwischen " + strings[i]
                        + " und " + strings[j] + ": " + distance);
            }
        }
    }

    private static String singleHamming_Distance(String s1, String s2) {
        int hammingDistance = 0;
        int length;
        // testen ob beide Strings gleich lang sind 
        // -> nur gleichlange Strings/Sequenzen sind auf der Hamming Distance definiert
        if ((length = s1.length()) == s2.length()) {
            // Umwandlung der Strings in CharArrays, damit man sie charweise verglichen kann                          
            char[] charS1 = s1.toCharArray();
            char[] charS2 = s2.toCharArray();

            // vergleiche die beiden Strings, für jeden unterschiedlichen Char wird die 
            // Hamming Distance um eins erhöht
            for (int i = 0; i < length; i++) {
                if (charS1[i] != charS2[i]) {
                    hammingDistance++;
                }
            }
            // String sind gleich lang, int in String konvertieren
            return String.valueOf(hammingDistance);
        } else {
            // Die Strings waren nicht gleich lang
            return "Nicht definiert";
        }
    }
}
